# tkcount.pl Perl/Tk ɂWvGUI

use encoding "shiftjis";
use Tk;
use Cwd;
use Encode qw(encode);

$tkflag = 1;

require "checksub.pl";		# Tu[`
require "check1.pl";		# L[[ho
require "check2.pl";		# ꎟWv
require "codech.pl";		# R[h`FbN
require "mkgraph.pl";		# Ot쐬
require "postfix.pl";           # `FbN
require "checkentry.pl";        # config
require "entry1.pl";            # VGg[`FbN
require "entry2.pl";            # VGg[`FbN
require "diffz.pl";		# zt@C荇킹
require "diffline.pl";		# ȈՂ荇킹

$iehandle = "IE00001";

@tk_acolor = @color;
$tk_acolor[3] = "#008000";
@tk_bcolor = ("WHITE",   "#FFBFBF", "#9FCFFF", "#CEFFCE", "#D0B0B0", "#FFBFFF",
	      "#BFEFFF", "#F0F0F0", "#B0B0E8", "#90C0A8", "#C0C090", "#ECBFFF",
	      "#FFE9BF", "#E9FFBF", "#FFBFE9", "#E9BFFF", "#BFFFE9", "#BFE9FF", 
	      "#FFE9E9", "#E9FFE9", "#E9E9FF", "#FFFFE9", "#FFE9FF", "#E9FFFF",
	      "#FFD4BF", "#D4FFBF", "#FFBFD4", "#D4BFFF", "#BFFFD4", "#BFD4FF", 
	      "#FFD4D4", "#D4FFD4", "#D4D4FF", "#FFFFD4", "#FFD4FF", "#D4FFFF",
	      "#FFD4E9", "#FFE9D4", "#D4FFE9", "#E9FFD4", "#D4E9FF", "#E9D4FF", 
	      "#D4E9BF", "#E9D4BF", "#D4BFE9", "#E9BFD4", "#BFD4E9", 
	      "#D4E9E9", "#E9D4E9", "#E9E9D4", "#D4D4E9", "#D4E9D4", "#E9D4D4",
	      "#D4E9E9", "#E9D4E9", "#E9E9D4", "#FFFFD4", "#FFD4FF", "#D4FFFF",
	      "#FFD4E9", "#D4FFE9", "#FFE9D4", "#D4E9FF", "#E9FFD4", "#E9D4FF"); # \p

### $browser, $tk_wd ̐ݒ

if(!$browser) {
    $browser = "c:/Progra~1/Intern~1/iexplore.exe";
}
@tmp = split(/[\/\\]/, $browser);
$browser = "";
foreach (@tmp) {
    s/[Mm]y [Dd]ocuments/mydocu~1/;
    if(!/\./ && (length > 8)) {
	s/^(.{6}).*/$1~1/;
    }
    $browser .= "$_/";
}
$browser =~ s/\/$//;


@tmp = split(/[\/\\]/, Cwd::getcwd());
$tk_wd = "";
foreach (@tmp) {
    s/[Mm]y [Dd]ocuments/mydocu~1/;
    if(!/\./ && (length > 8)) {
	s/^(.{6}).*/$1~1/;
    }
    $tk_wd .= "$_\\";
}


##### Main Window ݒ

$mw = MainWindow -> new;

$mw->fontCreate('MS', -family => 'lr SVbN' );
if($tk_fontsize) {
    $tmpfont = "MS $tk_fontsize";
} else {
    $tmpfont = "MS 8";
}
$mw->optionAdd( '*font' => $tmpfont);
$mw->title("$titlekey g[igWvGUI");

if(-e "guiconfig.txt") {
    open GUICONF, "guiconfig.txt";
    $_ = <GUICONF>;
    chop;
    $mw->geometry($_);
    $_ = <GUICONF>;
    chop;
    $mw->state($_);
    $_ = <GUICONF>;
    chop;
    $fe_check = $_;
    $_ = <GUICONF>;
    chop;
    $t_check = $_;
    $_ = <GUICONF>;
    chop;
    $c_check = $_;
    close(GUICONF);
}

# {t[쐬
$frame_fig = $mw -> Frame(-label => "oI胊Xg(config.txt)", 
	                  -relief => 'groove',
			  -borderwidth => 2)->grid   # config.txt ҏWp
    ($frame_key = $mw -> Frame(-label => "[惊Xg(keyword.txt)",
	                       -relief => 'groove',
			       -borderwidth => 2), # keyword.txt ҏWp
     $frame_tab = $mw -> Frame(-label => "ꎟL[",
	                       -relief => 'groove',
			       -borderwidth => 2),   # table*.txt \
     -sticky => "nsew");

$frame_code = $mw -> Frame(-label => "R[h`FbN",
			   -relief => 'groove',
			   -borderwidth => 2)->grid # coderes*.txt \
    ($frame_grp = $mw -> Frame(-label => "Ot",
	                       -relief => 'groove',
			       -borderwidth => 2),	# Ot\
     "-", -sticky => "nsew");

$frame_message = $mw -> Frame(-relief => 'groove',
			      -borderwidth => 2)->grid
     ($frame_tou = $mw -> Frame(-relief => 'groove',
			       -borderwidth => 2) ,   # [Xgp \
     $mw -> Button(-text => "I", -command => \&close_window));

$mw->gridColumnconfigure(0, -weight => 1);
$mw->gridColumnconfigure(1, -weight => 1);
$mw->gridColumnconfigure(2, -weight => 1);
$mw->gridRowconfigure(0, -weight => 1);

### config.txt ҏWp $frame_fig

# 
$ff_date = $frame_fig -> Frame()->pack(-anchor => 'w');
$ff_date -> Label(-text => "")->pack(-side => left);
$ff_date -> Spinbox(-from => 2001, -to => 2099,  
	            -textvariable => \$date0, 
                    -increment => 1, -width => 4)->pack(-side => left);
$ff_date -> Label(-text => "N")->pack(-side => left);
$ff_date -> Spinbox(-from => 1, -to => 12,  
                    -textvariable => \$date1, 
                    -increment => 1, -width => 2)->pack(-side => left);
$ff_date -> Label(-text => "")->pack(-side => left);
$ff_date -> Spinbox(-from => 1, -to => 31,  
                    -textvariable => \$date2, 
		    -increment => 1, -width => 2)->pack(-side => left);
$ff_date -> Label(-text => "")->pack(-side => left);
$ff_date -> Button(-text => "today", -command => \&set_today)->pack(-side => left);

# Round No. ܂ dat no.
$ff_round = $frame_fig -> Frame()->pack(-anchor => 'w', -fill => 'x');
$ff_round -> Label(-text => "Xԍ")->pack(-side => left);
$ff_round -> Entry(-textvariable => \$roundall)
    ->pack(-side => left, -fill => 'x', -expand => 1);
$ff_round -> Button(-text => "clear", 
		    -command => sub { $roundall = ""; })->pack(-side => left);

# 
$ff_vote = $frame_fig -> Frame()->pack(-anchor => 'w');
$ff_vote -> Label(-text => "")->pack(-side => left);
$ff_vote -> Spinbox(-from => 1, -to => 30,  
                    -textvariable => \$tk_match, 
		    -increment => 1, -width => 2)->pack(-side => left);
$ff_vote -> Label(-text => "I萔")->pack(-side => left);
$ff_vote -> Spinbox(-from => 1, -to => 30,
	            -textvariable => \$tk_person, 
		    -increment => 1, -width => 3)->pack(-side => left);
$ff_vote -> Label(-text => "[\l")->pack(-side => left);
$ff_vote -> Spinbox(-from => 1, -to => 30,  
                    -textvariable => \$tk_maxp, 
		    -increment => 1, -width => 2)->pack(-side => left);
$ff_vote -> Button(-text => "set", 
		   -command => \&set_entry)->pack(-side => left);
$ff_vote -> Button(-text => "clear", 
		   -command => \&pentry_clear)->pack(-side => left);

# L[[hݒ̈
$fs_entry = $frame_fig -> Scrolled("Text", -width => 46, -height => 9, 
				   -scrollbars => 'ose', 
				   -background => "#888888",
				   -wrap => 'none')
    -> pack(-fill => 'both', -expand => 1);

# \[hIWI{^
if(!$fe_check) {
    $fe_check = 0;
}
$ff_radio = $frame_fig -> Frame()->pack;
$ff_radio->Label(-text => "̓[h@")->pack(-side => left);
$ff_radio->Radiobutton(-text => "ʓ", -value => 0,
		       -command => \&change_entry,
		       -variable => \$fe_check)->pack(-side => left);
$ff_radio->Radiobutton(-text => "R", -value => 1,
		       -command => \&change_entry,
		       -variable => \$fe_check)->pack(-side => left);
$ff_radio -> Button(-text => "iȗkeywordǉ", 
		    -command => \&add_onlyname)->pack(-side => left);

    
# [X
$ff_ngres = $frame_fig -> Frame()->pack(-anchor => 'w', -fill => 'x');
$ff_ngres -> Label(-text => "[X")->pack(-side => left);
$ff_ngres -> Entry(-textvariable => \$f_ngres)
    ->pack(-side => left, -fill => 'x', -expand => 1);
$ff_ngres -> Button(-text => "clear", 
		    -command => sub { $f_ngres = ""; })->pack(-side => left);

# L[X
$ff_okres = $frame_fig -> Frame()->pack(-anchor => 'w', -fill => 'x');
$ff_okres -> Label(-text => "L[X")->pack(-side => left);
$ff_okres -> Entry(-textvariable => \$f_okres)
    ->pack(-side => left, -fill => 'x', -expand => 1);
$ff_okres -> Button(-text => "clear",
		    -command => sub { $f_okres = ""; })->pack(-side => left);

# NGID
$ff_ngid = $frame_fig -> Frame()->pack(-anchor => 'w', -fill => 'x');
$ff_ngid -> Label(-text => "NGID")->pack(-side => left);
$ff_ngid -> Entry(-textvariable => \$f_ngid)
    ->pack(-side => left, -fill => 'x', -expand => 1);
$ff_ngid -> Button(-text => "clear",
		   -command => sub { $f_ngid = ""; })->pack(-side => left);

# NGword
$ff_ngword = $frame_fig -> Frame()->pack(-anchor => 'w', -fill => 'x');
$ff_ngword -> Label(-text => "NGword")->pack(-side => left);
$ff_ngword -> Entry(-textvariable => \$f_ngword)
    ->pack(-side => left, -fill => 'x', -expand => 1);
$ff_ngword -> Button(-text => "clear",
		     -command => sub { $f_ngword = ""; })->pack(-side => left);

# NGcode
$ff_ngcode = $frame_fig -> Frame()->pack(-anchor => 'w', -fill => 'x');
$ff_ngcode -> Label(-text => "NGcode")->pack(-side => left);
$ff_ngcode -> Entry(-textvariable => \$f_ngcode)
    ->pack(-side => left, -fill => 'x', -expand => 1);
$ff_ngcode -> Button(-text => "clear",
		     -command => sub { $f_ngcode = ""; })->pack(-side => left);

# {^
$ff_button = $frame_fig -> Frame()->pack; 
$ff_button->Button(-text => "load config.txt", 
		   -command => \&wrap_readconfig )->pack(-side => left);
$ff_button->Button(-text => "save config.txt", 
		   -command => \&wrap_writeconfig )->pack(-side => left);
$ff_button->Button(-text => "Gg[ǉ", 
		   -command => \&wrap_checkentry )->pack(-side => left);
$ff_button->Button(-text => "keywordos", -bg => 'yellow', -activebackground => 'yellow', 
		   -command => \&wrap_check1 )->pack(-side => left);


### keyword.txt ҏWp $frame_key

# L[[hݒ̈
$ks_entry = $frame_key -> Scrolled("Text", -width => 50, -height => 22, 
				   -scrollbars => 'se', 
				   -background => "#cccccc",
				   -wrap => 'none')
    -> pack(-fill => 'both', -expand => 1);

# {^
$kf_button = $frame_key -> Frame()->pack; 
$kf_button->Button(-text => "keyword荇킹", 
		   -command => \&wrap_diffline )->pack(-side => left);
$kf_button->Button(-text => "load keyword.txt", 
		   -command => \&wrap_readkey )->pack(-side => left);
$kf_button->Button(-text => "save keyword.txt", 
		   -command => \&wrap_writekey )->pack(-side => left);
$kf_button->Button(-text => "ꎟWv", -bg => 'yellow', -activebackground => 'yellow', 
		   -command => \&wrap_check2 )->pack(-side => left);


### table*.txt \p $frame_tab

# ʕ\̈
$ts_entry = $frame_tab -> Scrolled("Text", -width => 50, -height => 20,
				   -scrollbars => 'ose',
				   -wrap => 'none')
    -> pack(-fill => 'both', -expand => 1);

for($i=0; $i<@tk_acolor; $i++) {
    $ts_entry->tagConfigure( "COL$i", -foreground => $tk_acolor[$i] );
}


# \eIWI{^
if(!$t_check) {
    $t_check = 0;
}
$tf_radio = $frame_tab -> Frame()->pack;
$tf_radio->Label(-text => "\e@")->pack(-side => left);
$tf_radio->Radiobutton(-text => "ŏ", -value => 0, -command => \&readtable, 
		       -variable => \$t_check)->pack(-side => left);
$tf_radio->Radiobutton(-text => "Ȉ", -value => 1, -command => \&readtable, 
		       -variable => \$t_check)->pack(-side => left);
$tf_radio->Radiobutton(-text => "ڍ", -value => 2, -command => \&readtable, 
		       -variable => \$t_check)->pack(-side => left);
$tf_radio->Radiobutton(-text => "S", -value => 3, -command => \&readtable, 
		       -variable => \$t_check)->pack(-side => left);


# {^
$tf_button1 = $frame_tab -> Frame()->pack; 
$tf_button1->Button(-text => "tablet@CǍ", 
		   -command => \&readtable )->pack(-side => left);
$tf_button1->Button(-text => "log*.html\", 
		   -command => \&t_logdisp )->pack(-side => left);
$tf_button1->Button(-text => "R[h`FbN", -bg => 'yellow', -activebackground => 'yellow', 
		   -command => \&wrap_codech )->pack(-side => left);
$tf_button2 = $frame_tab -> Frame()->pack; 
$tf_button2->Button(-text => "Ot쐬", 
		   -command => \&wrap_mkgrapht )->pack(-side => left);
$tf_button2->Button(-text => "Ot쐬E\", 
		   -command => \&wrap_mkgraphtb )->pack(-side => left);
$tf_button2->Button(-text => "f[^", 
		   -command => \&wrap_postfix )->pack(-side => left);


### coderes*.txt \p $frame_code

# ʕ\̈
$cs_entry = $frame_code -> Scrolled("Text", -width => 45, -height => 18,
				   -scrollbars => 'ose', 
				    -wrap => 'none') -> pack(-fill => 'both');

for($i=0; $i<@tk_acolor; $i++) {
    $cs_entry->tagConfigure( "COL$i", -foreground => $tk_acolor[$i] );
}

# \eI`FbN{bNX
if(!$c_check) {
    $c_check = 0;
}
$cf_radio = $frame_code -> Frame()->pack;
$cf_radio->Label(-text => "\e@")->pack(-side => left);
$cf_radio->Radiobutton(-text => "ŏ", -value => 0, -command => \&readcoderes_t, 
		       -variable => \$c_check)->pack(-side => left);
$cf_radio->Radiobutton(-text => "Ȉ", -value => 1, -command => \&readcoderes_t, 
		       -variable => \$c_check)->pack(-side => left);
$cf_radio->Radiobutton(-text => "ڍ", -value => 2, -command => \&readcoderes_t, 
		       -variable => \$c_check)->pack(-side => left);
$cf_radio->Radiobutton(-text => "S", -value => 3, -command => \&readcoderes_t, 
		       -variable => \$c_check)->pack(-side => left);

# {^
$cf_button1 = $frame_code -> Frame()->pack; 
$cf_button1->Button(-text => "coderest@CǍ", 
		   -command => \&readcoderes_t )->pack(-side => left);
$cf_button1->Button(-text => "coderes*.html\", 
		   -command => \&t_coderesdisp )->pack(-side => left);
$cf_button1->Button(-text => "Ot쐬", -bg => 'yellow', -activebackground => 'yellow', 
		   -command => \&wrap_mkgraph )->pack(-side => left);
$cf_button2 = $frame_code -> Frame()->pack; 
$cf_button2->Button(-text => "Ot쐬E\", 
		   -command => \&wrap_mkgraphb )->pack(-side => left);
$cf_button2->Button(-text => "f[^", 
		   -command => \&wrap_postfix )->pack(-side => left);
$cf_button2->Button(-text => "Gg[", 
		   -command => \&wrap_entry1 )->pack(-side => left);
$cf_button2->Button(-text => "荇킹", 
		   -command => \&wrap_diffz )->pack(-side => left);


### Ot\p $frame_grp
$gs_entry = $frame_grp -> Scrolled("Text", 
				   -width => 105, -height => 22, 
				   -scrollbars => 's', 
				   -wrap => 'none')->pack(-fill => 'both');


### bZ[WEBhE
$ms_entry = $frame_message -> Scrolled("Text", -width => 60, -height => 5,
				       -scrollbars => 'e', 
				       -wrap => 'none') -> pack(-side => left);

### [Xgp󋵕\
$to_entry = $frame_tou -> Scrolled("Text", -width => 60, -height => 5,
				       -scrollbars => 'e', 
				       -wrap => 'none') -> pack(-side => left);
for($i=0; $i<@tk_acolor; $i++) {
    $to_entry->tagConfigure( "COL$i", -foreground => $tk_acolor[$i] );
}




&wrap_readconfig();
&wrap_readkey();
&readtable();
&readcoderes_t();
#&display_graph();

MainLoop();

########## sub routine

# Gg[Zbg̐ςăNA
sub pentry_clear {
    local($tmp, $i);

    @tk_metakey = ();
    &display_entry;
}

# config.txt ̓ǂݍ
sub wrap_readconfig {
    @metakey = ();
    &readconfig();
    $date0 = $date[0] + 2000;
    $date1 = int($date[1]);
    $date2 = int($date[2]);
    $roundall = "";
    foreach (@roundno) {
	$roundall .= "$_ ";
    }
    $tk_match = $match;
    $tk_person = $person;
    $tk_maxp = $maxp;
    @tk_metakey = @metakey;

    # L[[ht@C
    &display_entry();
    $ms_entry->insert('end', "load config.txt\n");
    $ms_entry->see('end');
}

# {ݒ
sub set_today {
    local(@tmptime);

    @tmptime = localtime(time);
    $date0 = $tmptime[5] + 1900;
    $date1 = $tmptime[4] + 1;
    $date2 = $tmptime[3];
}


# Gg[̕\
sub display_entry {
    local($i, $j, $tmp, $tmpcol);

    $fs_entry->configure(-state => 'normal');
    $fs_entry->delete("1.0", 'end');
    if($fe_check) {
	$fs_entry->configure(-background => "white");
	for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	    $fs_entry->insert('end', "$tk_metakey[$i]\n");
	}
	$fs_entry->insert('end', "$tk_metakey[0]");
    } else {
	$fs_entry->configure(-background => "#cccccc");
	for($i=1; $i<$tk_match+1; $i++) {
	    for($j=1; $j<$tk_person+1; $j++) {
		$tmp = ($i-1)*$tk_person+$j;
		if($j < @tk_bcolor) {
		    $tmpcol = $j;
		} else {
		    $tmpcol = @tk_bcolor - 1;
		}
		if($tk_match > 1) {
		    $fsl[$tmp] = $fs_entry -> Label(-text => "$i-$j($tmp)", -width => 6, -bg => $tk_bcolor[$tmpcol]);
		} else {
		    $fsl[$tmp] = $fs_entry -> Label(-text => "$j", -width => 3, -bg => $tk_bcolor[$tmpcol]);
		}
		$fs_entry->windowCreate('end', -window => $fsl[$tmp]);
		$fse[$tmp] = $fs_entry -> Entry(-textvariable => \$tk_metakey[$tmp], -width => -1);
		$fs_entry->windowCreate('end', -window => $fse[$tmp]);
		$fs_entry->insert('end', "\n");
	    }
	}
	$fsl[0] = $fs_entry -> Label(-text => "NGkey", -width => 6);
	$fs_entry->windowCreate('end', -window => $fsl[0]);
	$fse[0] = $fs_entry -> Entry(-textvariable => \$tk_metakey[0], -width => -1);
	$fs_entry->windowCreate('end', -window => $fse[0]);
	$fs_entry->configure(-state => 'disabled');
    }
}

sub set_entry {
    local($i, @tmpall);
    if($fe_check) {
	@tmpall = split(/\n/, $fs_entry->get("1.0", "end"));
	for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	    $tk_metakey[$i] = $tmpall[$i-1];
	}
	$tk_metakey[0] = $tmpall[$tk_match*$tk_person];
    }
    &display_entry();
}

sub change_entry {
    local($i, @tmpall);
    unless($fe_check) {
	@tmpall = split(/\n/, $fs_entry->get("1.0", "end"));
	for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	    $tk_metakey[$i] = $tmpall[$i-1];
	}
	$tk_metakey[0] = $tmpall[$tk_match*$tk_person];
    }
    &display_entry();
}

# E@EiE( ȍ~̂keywordɒǉ
sub add_onlyname {
    local($i, @tmpkey);

    for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	@tmpkey = split(/,/, $tk_metakey[$i]);
	if($tmpkey[0] =~ s/[\@i\(].*//) {
	    $tk_metakey[$i] .= ",$tmpkey[0]";
	}
    }
    &display_entry();
}

# config.txt ̏o
sub wrap_writeconfig {
    local($i, $j, $filename, $tmp);

    $filename = sprintf("config%02d%02d.txt", $date1, $date2);
    open FIG, ">:encoding(shift-jis)", $filename;
    $tmp = sprintf("%02d/%02d/%02d", $date0-2000, $date1, $date2);
    enc_print(FIG, $tmp);
    enc_print(FIG, "$roundall");
    enc_print(FIG, "$tk_match $tk_person $tk_maxp");
    for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	enc_print(FIG, "$tk_metakey[$i]");
    }
    enc_print(FIG, "NGkey $tk_metakey[0]");
    enc_print(FIG, "NGres $f_ngres");
    enc_print(FIG, "OKres $f_okres");
    enc_print(FIG, "NGID $f_ngid");
    enc_print(FIG, "NGword $f_ngword");
    enc_print(FIG, "NGcode $f_ngcode");
    enc_print(FIG, "end");

    close(FIG);
    system("copy $filename $configfile");
    $ms_entry->insert('end', "save $configfile, $filename\n");
    $ms_entry->see('end');
}

# checkentry.pl ̎s
sub wrap_checkentry {
    $ms_entry->insert('end', "\nGg[ǉJn\n");
    &main_checkentry();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->insert('end', "Gg[ǉI\n");
    $ms_entry->see('end');
    &wrap_readconfig();
}

# check1.pl ̎s
sub wrap_check1 {
    $ms_entry->insert('end', "\nkeywordoJn\n");
    &wrap_writeconfig();
    $tk_message = "";
    &main_check1();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    &wrap_readkey();
    $ms_entry->insert('end', "keywordoI\n");
    $ms_entry->see('end');
}

###

# keyword.txt 荇킹
sub wrap_diffline {
    local($ret, $tmpfile);
    $ms_entry->insert('end', "\nkeyword 荇킹Jn\n");
    $tk_message = "";
    $ret = &main_diffline();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    if($ret > 0) {
	if(-e $anotherkey) {
	    $tmpfile = "$tk_wd" . "keyword.txt";
	    if(-e $tmpfile) {
		open($iehandle, "|$browser $tmpfile");
		$iehandle++;
		$ms_entry->insert('end', "keyword.txt \܂\n");
	    } else {
		$ms_entry->insert('end', "keyword.txt \ł܂\n");
	    }
	    open($iehandle, "|$browser $anotherkey");
	    $iehandle++;
	    $ms_entry->insert('end', "$anotherkey \܂\n");
	}
	$ms_entry->see('end');
    }
}

# keyword.txt ̓ǂݍ
sub wrap_readkey {
    local(@keylist, $max, $tmpp, $tmpkey, $tmp, $tmpcol);

    %allkey = ();
    &readkey();
    %tk_allkey = %allkey;

    $max = 0;
    foreach (keys(%tk_allkey)) {
	push(@keylist, "$tk_allkey{$_} $_");
	if($tk_allkey{$_} > $max) {
	    $max = $tk_allkey{$_};
	}
    }
    if($tk_match*$tk_person > $max) {
	$max = $tk_match*$tk_person;
    }

    $ks_entry->configure(-state => 'normal');
    $ks_entry->delete("1.0", 'end');
    $tmp = 0;
    @ks_key = ();
    foreach (sort keysort (@keylist)) {
	/^(.*?) (.*)/;
	$tmpkey = $2;
	$ks_per[$tmp] = $1;
	$ks_key[$tmp] = $tmpkey;
	if($ks_per[$tmp] == 0) {
	    $tmpcol = 0;
	} else {
	    if($tk_person) {
		$tmpcol = ($ks_per[$tmp] - 1) % $tk_person + 1;
	    } else {
		$tmpcol = ($ks_per[$tmp] - 1) + 1;
	    }
	    if($tmpcol >= @tk_bcolor) {
		$tmpcol = @tk_bcolor - 1;
	    }
	}
	$ksb2[$tmp] = $ks_entry -> Button(-text => "set",
					  -command => [ \&update_key, $tmp]);
	$ks_entry->windowCreate('end', -window => $ksb2[$tmp]);
	$ksb1[$tmp] = $ks_entry -> Button(-text => "",
					  -command => [ \&reset_key, $tmp]);
	$ks_entry->windowCreate('end', -window => $ksb1[$tmp]);
	$ksb3[$tmp] = $ks_entry -> Button(-text => "",
					  -command => [ \&search_key, $ks_key[$tmp]]);
	$ks_entry->windowCreate('end', -window => $ksb3[$tmp]);
	$kss[$tmp] = $ks_entry -> Spinbox(-from => 0, -to => $max,
					  -textvariable => \$tk_allkey{$ks_key[$tmp]}, 
					  -increment => 1, -width => 3);
	$ks_entry->windowCreate('end', -window => $kss[$tmp]);
	$ksl[$tmp] = $ks_entry -> Label(-text => "$2", -bg => $tk_bcolor[$tmpcol]);
	$ks_entry->windowCreate('end', -window => $ksl[$tmp]);
	$ks_entry->insert('end', "\n");
	$tmp++;
    }
    $ks_entry->configure(-state => 'disabled');
    $ms_entry->insert('end', "load keyword.txt\n");
    $ms_entry->see('end');
}

sub reset_key {
    local($tmp) = @_;

    $tk_allkey{$ks_key[$tmp]} = 0;
}

sub update_key {
    local($tmp) = @_;

    if($tk_metakey[$tk_allkey{$ks_key[$tmp]}]) {
	$tk_metakey[$tk_allkey{$ks_key[$tmp]}] .= ",$ks_key[$tmp]";
    } else {
	$tk_metakey[$tk_allkey{$ks_key[$tmp]}] .= $ks_key[$tmp];
    }
    &display_entry();
}

# keyword.txt ̌
sub search_key {
    local($tmp) = @_;
    local($qu, $esc = '');
    $qu = encode('shiftjis', $tmp);
    ($qu =~ s/(\W)/sprintf("^%%%02X", ord($1))/ego) and $esc = '^';

    open($iehandle, "|$browser http://www.google.com/search?hl=ja$esc&lr=lang_ja$esc&inlang=ja$esc&ie=Shift_JIS$esc&q=$qu");
    $iehandle++;
    $ms_entry->insert('end', "$tmp ܂\n");
    $ms_entry->see('end');
}

# keyword.txt ̏o
sub wrap_writekey {
    local($filename, $key, @keylist);

    foreach (keys(%tk_allkey)) {
	push(@keylist, "$tk_allkey{$_} $_");
    }

    $filename = sprintf("keyword%02d%02d.txt", $date1, $date2);
    open KEY, ">:encoding(shift-jis)", $filename;
    foreach (sort keysort(@keylist)) {
	&enc_print(KEY, "$_");
    }
    close(KEY);
    system("copy $filename $keyfile");
    $ms_entry->insert('end', "save keyword.txt\n");
    $ms_entry->see('end');
}

# check2.pl ̎s
sub wrap_check2 {
    $ms_entry->insert('end', "\nꎟWvJn\n");
    &wrap_writekey();
    $tk_message = "";
    &main_check2();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    &readtable();
    $ms_entry->insert('end', "ꎟWvI\n");
    $ms_entry->see('end');
}

### 

# table*.txt Ǎ

sub readtable {
    local($tablefile, $subfix, $tmpdate, $num);
    
    $ts_entry->delete("1.0", 'end');

    $tmpdate = sprintf("table%02d%02d", $date1, $date2);
    $tablefile = $tmpdate . ".txt";
    &readtablez();
    if(-e $tablefile) {
	&readtablesub($tablefile, 0);
	$ms_entry->insert('end', "read $tablefile\n");
    } else {
	$subfix = 'a';
	$num = 1;
	while(1) {
	    $tablefile = $tmpdate . $subfix . ".txt";
	    if(-e $tablefile) {
		$ts_entry->insert('end', "$num" . "\n");
		&readtablesub($tablefile, 0);
		$ms_entry->insert('end', "read $tablefile\n");
		$ts_entry->insert('end', "\n");
		$subfix++;
		$num++;
	    } else {
		if($subfix eq "a") {
		    $ms_entry->insert('end', "no tablefile\n");
		    $ts_entry->insert('end', "tablet@C܂\n");
		}
		last;
	    }
	}
    }
    $ms_entry->see('end');
}

# ۂtable*.txt ̓ǍƏo

sub readtablesub {
    local($filename, $check) = @_;
    local($i, $per, $col, $check, $tmpstr, $tmpname);
    
    open(TABLE, "<:encoding(shift-jis)", $filename);
    while(<TABLE>) {
	if($t_check == 0) {
	    unless(/ʁ@\d+[@/) {
		last;
	    }
	} elsif($t_check == 1) {
	    if(/^/) {
		last;
	    }
	} elsif($t_check == 2) {
	    if(/^ԑѕʓ[/) {
		last;
	    }
	}
	$check = 0;
	for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	    $tmpstr = $_;
	    $tmpstr = &sanitize2($tmpstr);
	    $tmpname = $name[$i];
	    $tmpname = &sanitize2($tmpname);
	    if($tmpstr =~ /$tmpname/ && $tmpstr =~ /^(.*)($tmpname)(.*)/) {
		$per = ($i-1) % $tk_person + 1;
		if($per < @tk_acolor) {
		    $col = $per;
		} else {
		    $col = @tk_acolor - 1;
		}
		$ts_entry->insert('end', $1);
		$ts_entry->insert('end', $2, "COL$col");
		$ts_entry->insert('end', $3 . "\n");
		$check = 1;
		last;
	    }
	}
	unless($check) {
	    $ts_entry->insert('end', $_);
	}
    }
    close(TABLE);
}

# tablezt@C瓊[\
sub readtablez {
    my $filename = $tablefile;
    my ($datfile, $res, $size);

    $to_entry->delete("1.0", 'end');
    $to_entry->insert('end', "[X̎gp\n");
    $filename =~ s/table/tablez/; 
    open(TABLEZ, "<:encoding(shift-jis)", $filename) || return;  
    while(<TABLEZ>) {
	if(/^\#([^\s]+)\slast\=(.{3})\ssize\=(.{6})\s.+/) {
	    $res = sprintf("%d", $2);
	    $size = sprintf("%d", $3);
	    if(($res > 980) || ($size > 490*1024)) {	
		$to_entry->insert('end', "$&\n", "COL1");
	    } else {
		$to_entry->insert('end', "$&\n");
	    }
	}
	if(/([.+)/) {
	    $ts_entry->insert('end', "$&\n\n");
	    last;
	}
    }
    close(TABLEZ);
}

# sR[h擾

sub wrap_codech {
    $ms_entry->insert('end', "\nR[h`FbNJn\n");
    &readtable();
    $tk_message = "";
    &main_codech();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    &readcoderes_t();
    $ms_entry->insert('end', "R[h`FbNI\n");
    $ms_entry->see('end');
}

# log*.html uEUŕ\
sub t_logdisp {
    local($logfile, $subfix, $tmpdate, $num, $tmpfile);
    
    $tmpdate = sprintf("log%02d%02d", $date1, $date2);
    $logfile = $tmpdate . ".html";
    if(-e $logfile) {
	$tmpfile = "$tk_wd$logfile";
	if(-e $tmpfile) {
	    open($iehandle, "|$browser $tmpfile");
	    $iehandle++;
	    $ms_entry->insert('end', "$logfile \܂\n");
	} else {
	    $ms_entry->insert('end', "$logfile \ł܂\n");
	}
    } else {
	$subfix = 'a';
	$num = 1;
	while(1) {
	    $logfile = $tmpdate . $subfix . ".html";
	    if(-e $logfile) {
		$tmpfile = "$tk_wd$logfile";
		if(-e $tmpfile) {
		    open($iehandle, "|$browser $tmpfile");
		    $iehandle++;
		    $ms_entry->insert('end', "$logfile \܂\n");
		} else {
		    $ms_entry->insert('end', "$logfile \ł܂\n");
		}
		$subfix++;
		$num++;
	    } else {
		if($subfix eq "a") {
		    $ms_entry->insert('end', "logt@C܂\n");
		}
		last;
	    }
	}
    }
    $ms_entry->see('end');

}


### 

# coderes*.txt Ǎ

sub readcoderes_t {
    local($coderesfile, $check, $i, $check2, $per);
    
    $cs_entry->delete("1.0", 'end');

    $check = 0;
    $coderesfile = sprintf("coderes%02d%02d.txt", $date1, $date2);
    if(-e $coderesfile) {
	open(CODERES, "<:encoding(shift-jis)", $coderesfile);

	while(<CODERES>) {
	    if(/([.+)/) {
		$cs_entry->insert('end', "$&\n\n");
		last;
	    }
	}
	close(CODERES);
	open(CODERES, "<:encoding(shift-jis)", $coderesfile);

	while(<CODERES>) {
	    if($c_check == 0) {
		if((/^/) || (/ʁ@\d+[@/)) {
		    if(/^/ && !//) {
			$cs_entry->insert('end', "\n");
		    }
		    &readcoderes_t_sub($_);
		}
	    } elsif($c_check == 1) {
		if(/^/ || /@L[/) {
		    $check = 1;
		}
		if($check) {
		    &readcoderes_t_sub($_);
		}
	    } elsif($c_check == 2) {
		if(/^gpR[h/) {
		    $check = 1;
		}
		if($check) {
		    if(/^/ || /@L[/) {
			$check = 0;
		    }
		} else {
		    &readcoderes_t_sub($_);
		}
	    } else {
		&readcoderes_t_sub($_);
	    }
	}
	close(CODERES);
	$ms_entry->insert('end', "read $coderesfile\n");
    } else {
	$ms_entry->insert('end', "no coderesfile\n");
	$cs_entry->insert('end', "R[ht@C܂\n");
    }
    $ms_entry->see('end');
}

# 
sub readcoderes_t_sub {
    local($str) = @_;
    local($i, $per, $col, $check, $tmpstr, $tmpname);
    
    $check = 0;
    for($i=1; $i<$tk_match*$tk_person+1; $i++) {
	$tmpstr = $str;
	$tmpstr = &sanitize2($tmpstr);
	$tmpname = $name[$i];
	$tmpname = &sanitize2($tmpname);
	if(($tmpstr =~ /$tmpname/) && ($tmpstr =~ /^(.*)($tmpname)(.*)/)) {
	    $per = ($i-1) % $tk_person + 1;
	    if($per < @tk_acolor) {
		$col = $per;
	    } else {
		$col = @tk_acolor - 1;
	    }
	    $cs_entry->insert('end', $1);
	    $cs_entry->insert('end', $2, "COL$col");
	    $cs_entry->insert('end', $3 . "\n");
	    $check = 1;
	    last;
	}
    }
    unless($check) {
	$cs_entry->insert('end', $str);
    }
}


# coderes*.html uEUŕ\
sub t_coderesdisp {
    local($coderesfile, $tmpfile);
    
    $coderesfile = sprintf("coderes%02d%02d.html", $date1, $date2);
    if(-e $coderesfile) {
	$tmpfile = "$tk_wd$coderesfile";
	if(-e $tmpfile) {
	    open($iehandle, "|$browser $tmpfile");
	    $iehandle++;
	    $ms_entry->insert('end', "$coderesfile \܂\n");
	} else {
	    $ms_entry->insert('end', "$coderesfile \ł܂\n");
	}
    } else {
	$ms_entry->insert('end', "$coderesfile ܂\n");
    }
    $ms_entry->see('end');

}


# Ot쐬

sub wrap_mkgraph {
    $ms_entry->insert('end', "\nOt쐬Jn\n");
    &readcoderes_t();
    $tk_message = "";
    &main_mkgraph(0, 0);
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    $ms_entry->insert('end', "Ot쐬I\n");
    $ms_entry->see('end');
}

sub wrap_mkgraphb {
    $ms_entry->insert('end', "\nOt쐬Jn\n");
    &readcoderes_t();
    $tk_message = "";
    &main_mkgraph(1, 0);
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    &display_graph();
    $ms_entry->insert('end', "Ot쐬I\n");
    $ms_entry->see('end');
}

sub wrap_mkgrapht {
    $ms_entry->insert('end', "\nOt쐬Jn\n");
    &readtable();
    $tk_message = "";
    &main_mkgraph(0, 1);
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    $ms_entry->insert('end', "Ot쐬I\n");
    $ms_entry->see('end');
}

sub wrap_mkgraphtb {
    $ms_entry->insert('end', "\nOt쐬Jn\n");
    &readtable();
    $tk_message = "";
    &main_mkgraph(1, 1);
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    &display_graph();
    $ms_entry->insert('end', "Ot쐬I\n");
    $ms_entry->see('end');
}

sub display_graph {
    local($subfix, $i, $filename);

    $gs_entry->configure(-state => 'normal');
    $gs_entry->delete("1.0", 'end');
    if($tk_match > 1) {
	$subfix = 'a';
    } else {
	$subfix = '';
    }
    for($i=0; $i<$tk_match; $i++) {
	$filename = sprintf("sgraph%02d%02d$subfix.gif", $date1, $date2);
	if(-e $filename) {
	    $imgfile[$i] = $mw->Photo(-file => $filename);
	    $gs_entry -> imageCreate('end', -image => $imgfile[$i]);
	    $subfix++;
	}
    }
    $gs_entry->insert('end', "\n");
    $gs_entry->configure(-state => 'disabled');
}


# postfix.pl ̎s
sub wrap_postfix {
    local($postfixfile, $tmpfile);

    $ms_entry->insert('end', "\nf[^͊Jn\n");
    $tk_message = "";
    &main_postfix(0);
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    $postfixfile = sprintf("postfix%02d%02d.html", $date1, $date2);
    $miningfile = sprintf("mining%02d%02d.html", $date1, $date2);
    if(-e $postfixfile) {
	$tmpfile = "$tk_wd$postfixfile";
	if(-e $tmpfile) {
	    open($iehandle, "|$browser $tk_wd$postfixfile");
	    $iehandle++;
	    $ms_entry->insert('end', "$postfixfile \܂\n");
	} else {
	    $ms_entry->insert('end', "$postfixfile \ł܂\n");
	}
	$tmpfile = "$tk_wd$miningfile";
	if(-e $tmpfile) {
	    open($iehandle, "|$browser $tk_wd$miningfile");
	    $iehandle++;
	    $ms_entry->insert('end', "$miningfile \܂\n");
	} else {
	    $ms_entry->insert('end', "$miningfile \ł܂\n");
	}
    } else {
	$ms_entry->insert('end', "$postfixfile ܂\n");
    }
    $ms_entry->insert('end', "f[^͏I\n");
    $ms_entry->see('end');
}

# entry1.pl ̎s
sub wrap_entry1 {
    local($newcharfile2, $tmpfile);
    $ms_entry->insert('end', "\nGg[Jn\n");
    $tk_message = "";
    &main_entry1(0);
    &main_entry2();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
#    if(-e $newtitlefile) {
#	open($iehandle, "|$browser $tk_wd$newtitlefile");
#	$iehandle++;
#	$ms_entry->insert('end', "$newtitlefile \܂\n");
#    } else {
#	$ms_entry->insert('end', "$newtitlefile ܂\n");
#    }
    $newcharfile2 = sprintf("newchar%02d%02d.txt", $date1, $date2);
    if(-e $newcharfile2) {
	$tmpfile = "$tk_wd$newcharfile2";
	if(-e $tmpfile) {
	    open($iehandle, "|$browser $tmpfile");
	    $iehandle++;
	    $ms_entry->insert('end', "$newcharfile2 \܂\n");
	} else {
	    $ms_entry->insert('end', "$newcharfile2 \ł܂\n");
	}
    } else {
	$ms_entry->insert('end', "$newcharfile2 ܂\n");
    }
    $ms_entry->insert('end', "Gg[I\n");
    $ms_entry->see('end');
}

# diffz.pl ̎s
sub wrap_diffz {
    local($ret, $diffzfile, $tmpfile);
    $ms_entry->insert('end', "\ncoderesz 荇킹Jn\n");
    $tk_message = "";
    $ret = &main_diffz();
    $ms_entry->insert('end', $tk_message);
    $ms_entry->see('end');
    if($ret > 0) {
	$diffzfile = "diffzres.html";
	if(-e $diffzfile) {
	    $tmpfile = "$tk_wd$diffzfile";
	    if(-e $tmpfile) {
		open($iehandle, "|$browser $tk_wd$diffzfile");
		$iehandle++;
		$ms_entry->insert('end', "$diffzfile \܂\n");
	    } else {
		$ms_entry->insert('end', "$diffzfile \ł܂\n");
	    }
	} else {
	    $ms_entry->insert('end', "$diffzfile ܂\n");
	}
	$ms_entry->see('end');
    }
}


### I
sub close_window {
    open(GUICONF, ">guiconfig.txt");
    $tmp = $mw->geometry;
    print GUICONF "$tmp\n";
    $tmp = $mw->state;
    print GUICONF "$tmp\n";
    print GUICONF "$fe_check\n";
    print GUICONF "$t_check\n";
    print GUICONF "$c_check\n";
    close(GUICONF);
    exit;
}
